
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java Nio 异步操作（三） / iVAN</title>

    <meta name="description" content="java Nio 异步操作（三） 异步channel API 主要引入三个异步类: AsynchronousFileChannel,AsynchronousSocketChannel, and AsynchronousServerSocketChannel. AsynchronousFileChannel跟FileChannel区别:不保存全局的position和offset,可以制定访问位置,也支持并发访问文件不同. AsynchronousServerSocketChannel AsynchronousSocketChann">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">java Nio 异步操作（三）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>异步channel API</p>
<p>主要引入三个异步类: AsynchronousFileChannel,AsynchronousSocketChannel, and AsynchronousServerSocketChannel.</p>
<p>AsynchronousFileChannel跟FileChannel区别：不保存全局的position和offset，可以制定访问位置，也支持并发访问文件不同。</p>
<p>AsynchronousServerSocketChannel AsynchronousSocketChannel：能够绑定到一个制定线程池的组中，这个线程池能够用future或者CompletionHandler来对执行结果进行处理，</p>
<p>AsynchronousChannelGroup：执行异步IO的java线程池的组类，</p>
<p>AsynchronousChannelGroup.java:</p>
<p>public static AsynchronousChannelGroup withFixedThreadPool(int nThreads, ThreadFactory threadFactory)<br />
public static AsynchronousChannelGroup withCachedThreadPool(ExecutorService executor,int initialSize)<br />
public static AsynchronousChannelGroup withThreadPool(ExecutorService executor)​​​</p>
<p>我们看使用示例</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/zhongweijian/article/details/8455325#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/zhongweijian/article/details/8455325#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>package com.mime;  </li>
<li>  </li>
<li>import java.io.IOException;  </li>
<li>import java.net.InetSocketAddress;  </li>
<li>import java.net.StandardSocketOptions;  </li>
<li>import java.nio.ByteBuffer;  </li>
<li>import java.nio.channels.AsynchronousChannelGroup;  </li>
<li>import java.nio.channels.AsynchronousFileChannel;  </li>
<li>import java.nio.channels.AsynchronousServerSocketChannel;  </li>
<li>import java.nio.channels.AsynchronousSocketChannel;  </li>
<li>import java.nio.channels.CompletionHandler;  </li>
<li>import java.nio.channels.FileLock;  </li>
<li>import java.nio.charset.Charset;  </li>
<li>import java.nio.file.Path;  </li>
<li>import java.nio.file.Paths;  </li>
<li>import java.nio.file.StandardOpenOption;  </li>
<li>import java.util.ArrayList;  </li>
<li>import java.util.List;  </li>
<li>import java.util.Set;  </li>
<li>import java.util.TreeSet;  </li>
<li>import java.util.concurrent.Callable;  </li>
<li>import java.util.concurrent.ExecutionException;  </li>
<li>import java.util.concurrent.ExecutorService;  </li>
<li>import java.util.concurrent.Executors;  </li>
<li>import java.util.concurrent.Future;  </li>
<li>import java.util.concurrent.ThreadLocalRandom;  </li>
<li>  </li>
<li>public class NIO2AsynchronousFileChannel {  </li>
<li>    public static void main(String[] args) {  </li>
<li>          </li>
<li>        asyFile();  </li>
<li>        asyFileChannel2();  </li>
<li>        asyServerSocketChannel();  </li>
<li>    }  </li>
<li>  </li>
<li>    // 异步文件读写示例  </li>
<li>    public static void asyFile() {  </li>
<li>        ByteBuffer buffer = ByteBuffer.allocate(100);  </li>
<li>        String encoding = System.getProperty("file.encoding");  </li>
<li>        Path path = Paths.get("/tmp", "store.txt");  </li>
<li>        try (AsynchronousFileChannel asynchronousFileChannel = AsynchronousFileChannel  </li>
<li>                .open(path, StandardOpenOption.READ)) {  </li>
<li>            Future&lt;Integer&gt; result = asynchronousFileChannel.read(buffer, 0);  </li>
<li>            // 读超时控制  </li>
<li>            // int count = result.get(100, TimeUnit.NANOSECONDS);  </li>
<li>  </li>
<li>            while (!result.isDone()) {  </li>
<li>                System.out.println("Do something else while reading ...");  </li>
<li>            }  </li>
<li>            System.out.println("Read done: " + result.isDone());  </li>
<li>            System.out.println("Bytes read: " + result.get());  </li>
<li>  </li>
<li>            // 使用CompletionHandler回调接口异步读取文件  </li>
<li>            final Thread current = Thread.currentThread();  </li>
<li>            asynchronousFileChannel.read(buffer, 0,  </li>
<li>                    "Read operation status ...",  </li>
<li>                    new CompletionHandler&lt;Integer, Object&gt;() {  </li>
<li>                        @Override  </li>
<li>                        public void completed(Integer result, Object attachment) {  </li>
<li>                            System.out.println(attachment);  </li>
<li>                            System.out.print("Read bytes: " + result);  </li>
<li>                            current.interrupt();  </li>
<li>                        }  </li>
<li>  </li>
<li>                        @Override  </li>
<li>                        public void failed(Throwable exc, Object attachment) {  </li>
<li>                            System.out.println(attachment);  </li>
<li>                            System.out.println("Error:" + exc);  </li>
<li>                            current.interrupt();  </li>
<li>                        }  </li>
<li>                    });  </li>
<li>  </li>
<li>        } catch (Exception ex) {  </li>
<li>            System.err.println(ex);  </li>
<li>        }  </li>
<li>        buffer.flip();  </li>
<li>        System.out.print(Charset.forName(encoding).decode(buffer));  </li>
<li>        buffer.clear();  </li>
<li>  </li>
<li>        // 异步文件写示例  </li>
<li>        ByteBuffer buffer1 = ByteBuffer  </li>
<li>                .wrap("The win keeps Nadal at the top of the heap in men's"  </li>
<li>                        .getBytes());  </li>
<li>        Path path1 = Paths.get("/tmp", "store.txt");  </li>
<li>        try (AsynchronousFileChannel asynchronousFileChannel = AsynchronousFileChannel  </li>
<li>                .open(path1, StandardOpenOption.WRITE)) {  </li>
<li>            Future&lt;Integer&gt; result = asynchronousFileChannel  </li>
<li>                    .write(buffer1, 100);  </li>
<li>            while (!result.isDone()) {  </li>
<li>                System.out.println("Do something else while writing ...");  </li>
<li>            }  </li>
<li>            System.out.println("Written done: " + result.isDone());  </li>
<li>            System.out.println("Bytes written: " + result.get());  </li>
<li>  </li>
<li>            // file lock  </li>
<li>            Future&lt;FileLock&gt; featureLock = asynchronousFileChannel.lock();  </li>
<li>            System.out.println("Waiting for the file to be locked ...");  </li>
<li>            FileLock lock = featureLock.get();  </li>
<li>            if (lock.isValid()) {  </li>
<li>                Future&lt;Integer&gt; featureWrite = asynchronousFileChannel.write(  </li>
<li>                        buffer, 0);  </li>
<li>                System.out.println("Waiting for the bytes to be written ...");  </li>
<li>                int written = featureWrite.get();  </li>
<li>                // or, use shortcut  </li>
<li>                // int written = asynchronousFileChannel.write(buffer,0).get();  </li>
<li>                System.out.println("I’ve written " + written + " bytes into "  </li>
<li>                        + path.getFileName() + " locked file!");  </li>
<li>                lock.release();  </li>
<li>            }  </li>
<li>  </li>
<li>            // asynchronousFileChannel.lock("Lock operation status:", new  </li>
<li>            // CompletionHandler&lt;FileLock, Object&gt;() ;  </li>
<li>  </li>
<li>        } catch (Exception ex) {  </li>
<li>            System.err.println(ex);  </li>
<li>        }  </li>
<li>    }  </li>
<li>  </li>
<li>    // public static AsynchronousFileChannel open(Path file, Set&lt;? extends  </li>
<li>    // OpenOption&gt; options,ExecutorService executor, FileAttribute&lt;?&gt;... attrs)  </li>
<li>    // throws IOException  </li>
<li>    private static Set withOptions() {  </li>
<li>        final Set options = new TreeSet&lt;&gt;();  </li>
<li>        options.add(StandardOpenOption.READ);  </li>
<li>        return options;  </li>
<li>    }  </li>
<li>  </li>
<li>    // 使用AsynchronousFileChannel.open(path, withOptions(),  </li>
<li>    // taskExecutor))这个API对异步文件IO的处理  </li>
<li>    public static void asyFileChannel2() {  </li>
<li>        final int THREADS = 5;  </li>
<li>        ExecutorService taskExecutor = Executors.newFixedThreadPool(THREADS);  </li>
<li>        String encoding = System.getProperty("file.encoding");  </li>
<li>        List&lt;Future&lt;ByteBuffer&gt;&gt; list = new ArrayList&lt;&gt;();  </li>
<li>        int sheeps = 0;  </li>
<li>        Path path = Paths.get("/tmp",  </li>
<li>                "store.txt");  </li>
<li>        try (AsynchronousFileChannel asynchronousFileChannel = AsynchronousFileChannel  </li>
<li>                .open(path, withOptions(), taskExecutor)) {  </li>
<li>            for (int i = 0; i &lt; 50; i++) {  </li>
<li>                Callable&lt;ByteBuffer&gt; worker = new Callable&lt;ByteBuffer&gt;() {  </li>
<li>                    @Override  </li>
<li>                    public ByteBuffer call() throws Exception {  </li>
<li>                        ByteBuffer buffer = ByteBuffer  </li>
<li>                                .allocateDirect(ThreadLocalRandom.current()  </li>
<li>                                        .nextInt(100, 200));  </li>
<li>                        asynchronousFileChannel.read(buffer, ThreadLocalRandom  </li>
<li>                                .current().nextInt(0, 100));  </li>
<li>                        return buffer;  </li>
<li>                    }  </li>
<li>                };  </li>
<li>                Future&lt;ByteBuffer&gt; future = taskExecutor.submit(worker);  </li>
<li>                list.add(future);  </li>
<li>            }  </li>
<li>            // this will make the executor accept no new threads  </li>
<li>            // and finish all existing threads in the queue  </li>
<li>            taskExecutor.shutdown();  </li>
<li>            // wait until all threads are finished  </li>
<li>            while (!taskExecutor.isTerminated()) {  </li>
<li>                // do something else while the buffers are prepared  </li>
<li>                System.out  </li>
<li>                        .println("Counting sheep while filling up some buffers!So far I counted: "  </li>
<li>                                + (sheeps += 1));  </li>
<li>            }  </li>
<li>            System.out.println("\nDone! Here are the buffers:\n");  </li>
<li>            for (Future&lt;ByteBuffer&gt; future : list) {  </li>
<li>                ByteBuffer buffer = future.get();  </li>
<li>                System.out.println("\n\n" + buffer);  </li>
<li>                System.out  </li>
<li>                        .println("______________________________________________________");  </li>
<li>                buffer.flip();  </li>
<li>                System.out.print(Charset.forName(encoding).decode(buffer));  </li>
<li>                buffer.clear();  </li>
<li>            }  </li>
<li>        } catch (Exception ex) {  </li>
<li>            System.err.println(ex);  </li>
<li>        }  </li>
<li>    }  </li>
<li>  </li>
<li>    //异步server socket channel io处理示例  </li>
<li>    public static void asyServerSocketChannel() {  </li>
<li>          </li>
<li>        //使用threadGroup  </li>
<li>//      AsynchronousChannelGroup threadGroup = null;  </li>
<li>//      ExecutorService executorService = Executors  </li>
<li>//      .newCachedThreadPool(Executors.defaultThreadFactory());  </li>
<li>//      try {  </li>
<li>//      threadGroup = AsynchronousChannelGroup.withCachedThreadPool(executorService, 1);  </li>
<li>//      } catch (IOException ex) {  </li>
<li>//      System.err.println(ex);  </li>
<li>//      }  </li>
<li>//      AsynchronousServerSocketChannel asynchronousServerSocketChannel =  </li>
<li>//              AsynchronousServerSocketChannel.open(threadGroup);  </li>
<li>          </li>
<li>        final int DEFAULT_PORT = 5555;  </li>
<li>        final String IP = "127.0.0.1";  </li>
<li>        ExecutorService taskExecutor = Executors.newCachedThreadPool(Executors  </li>
<li>                .defaultThreadFactory());  </li>
<li>        // create asynchronous server socket channel bound to the default group  </li>
<li>        try (AsynchronousServerSocketChannel asynchronousServerSocketChannel = AsynchronousServerSocketChannel  </li>
<li>                .open()) {  </li>
<li>            if (asynchronousServerSocketChannel.isOpen()) {  </li>
<li>                // set some options  </li>
<li>                asynchronousServerSocketChannel.setOption(  </li>
<li>                        StandardSocketOptions.SO_RCVBUF, 4 * 1024);  </li>
<li>                asynchronousServerSocketChannel.setOption(  </li>
<li>                        StandardSocketOptions.SO_REUSEADDR, true);  </li>
<li>                // bind the server socket channel to local address  </li>
<li>                asynchronousServerSocketChannel.bind(new InetSocketAddress(IP,  </li>
<li>                        DEFAULT_PORT));  </li>
<li>                // display a waiting message while ... waiting clients  </li>
<li>                System.out.println("Waiting for connections ...");  </li>
<li>                while (true) {  </li>
<li>                    Future&lt;AsynchronousSocketChannel&gt; asynchronousSocketChannelFuture = asynchronousServerSocketChannel.accept();  </li>
<li>                    //使用CompletionHandler来处理IO事件  </li>
<li>//                  asynchronousServerSocketChannel.accept(null, new CompletionHandler&lt;AsynchronousSocketChannel, Void&gt;()   </li>
<li>                    //client使用CompletionHandler来处理IO事件  </li>
<li>                    //asynchronousSocketChannel.connect(new InetSocketAddress(IP, DEFAULT_PORT), null,new CompletionHandler&lt;Void, Void&gt;()   </li>
<li>                    try {  </li>
<li>                        final AsynchronousSocketChannel asynchronousSocketChannel = asynchronousSocketChannelFuture  </li>
<li>                                .get();  </li>
<li>                        Callable&lt;String&gt; worker = new Callable&lt;String&gt;() {  </li>
<li>                            @Override  </li>
<li>                            public String call() throws Exception {  </li>
<li>                                String host = asynchronousSocketChannel  </li>
<li>                                        .getRemoteAddress().toString();  </li>
<li>                                System.out.println("Incoming connection from: "  </li>
<li>                                        + host);  </li>
<li>                                final ByteBuffer buffer = ByteBuffer  </li>
<li>                                        .allocateDirect(1024);  </li>
<li>                                // transmitting data  </li>
<li>                                while (asynchronousSocketChannel.read(buffer)  </li>
<li>                                        .get() != -1) {  </li>
<li>                                    buffer.flip();  </li>
<li>                                }  </li>
<li>                                asynchronousSocketChannel.write(buffer).get();  </li>
<li>                                if (buffer.hasRemaining()) {  </li>
<li>                                    buffer.compact();  </li>
<li>                                } else {  </li>
<li>                                    buffer.clear();  </li>
<li>                                }  </li>
<li>                                asynchronousSocketChannel.close();  </li>
<li>                                System.out.println(host  </li>
<li>                                        + " was successfully served!");  </li>
<li>                                return host;  </li>
<li>                            }  </li>
<li>                        };  </li>
<li>                        taskExecutor.submit(worker);  </li>
<li>                    } catch (InterruptedException | ExecutionException ex) {  </li>
<li>                        System.err.println(ex);  </li>
<li>                        System.err.println("\n Server is shutting down ...");  </li>
<li>                        // this will make the executor accept no new threads  </li>
<li>                        // and finish all existing threads in the queue  </li>
<li>                        taskExecutor.shutdown();  </li>
<li>                        // wait until all threads are finished  </li>
<li>                        while (!taskExecutor.isTerminated()) {  </li>
<li>                        }  </li>
<li>                        break;  </li>
<li>                    }  </li>
<li>                }  </li>
<li>            } else {  </li>
<li>                System.out  </li>
<li>                        .println("The asynchronous server-socket channel cannot be opened!");  </li>
<li>            }  </li>
<li>        } catch (IOException ex) {  </li>
<li>            System.err.println(ex);  </li>
<li>        }  </li>
<li>  </li>
<li>    }  </li>
<li>}  </li>
</ol>
<p>输出：</p>
<p><strong>[html]</strong> <a href="http://blog.csdn.net/zhongweijian/article/details/8455325#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/zhongweijian/article/details/8455325#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Do something else while reading ...  </li>
<li>Read done: true  </li>
<li>Bytes read: 18  </li>
<li>hello,filechannel  </li>
<li>Read operation status ...  </li>
<li>Error:java.nio.channels.AsynchronousCloseException  </li>
<li>Do something else while writing ...  </li>
<li>Do something else while writing ...  </li>
<li>Do something else while writing ...  </li>
<li>Written done: true  </li>
<li>Bytes written: 51  </li>
<li>Waiting for the file to be locked ...  </li>
<li>Waiting for the bytes to be written ...  </li>
<li>I’ve written 100 bytes into store.txt locked file!  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 1  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 2  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 3  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 4  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 5  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 6  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 7  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 8  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 9  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 10  </li>
<li>Counting sheep while filling up some buffers!So far I counted: 11  </li>
<li>  </li>
<li>Done! Here are the buffers:  </li>
<li>  </li>
<li>java.lang.InterruptedException  </li>
<li>Waiting for connections ... </li>
</ol>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 20:46:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/file/" title="file">file</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>java Nio 异步操作（三）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZL0Nb.html" rel="bookmark">java Nio 异步操作（四）channel</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java NIO 的核心组成部分: 1.Channels 2.Buffers 3.Selectors 我们首先来学习Channels(java.nio.channels): 通道 1)通道基础 通道(Channel)是java.nio的第二个主要创新.它们既不是一个扩展也不是一项增强,而是全新.极好的Java I/O示例,提供与I/O服务的直接连接.Channel用于在字节缓冲区和位于通道另一侧的实体(通常是一个文件或套接字)之间有效地传输数据. channel的jdk源码: 1 2 3 4 5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvnvY8M.html" rel="bookmark">java nio 异步操作 &lpar;一&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先来看些nio基础的类库关系图 用pd大致画了下 相关的图片 上面是一些理论的关系图 下面是一些测试代码  相关的代码 都加了必要的注释 文件通道  FileChannel package test; import java.io.IOException; import java.io.RandomAccessFile; import java.net.URISyntaxException; import java.nio.ByteBuffer; import java.nio.channels			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlLq3qM.html" rel="bookmark">Java NIO 完全学习笔记&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇博客依照 Java NIO Tutorial 翻译,算是学习 Java NIO 的一个读书笔记.建议大家可以去阅读原文,相信你肯定会受益良多. 1. Java NIO Tutorial Java NIO,被称为新 IO(New IO),是 Java 1.4 引入的,用来替代 IO API的. Java NIO:Channels and Buffers 标准的 Java IO API ,你操作的对象是字节流(byte stream)或者字符流(character stream),而 NIO,你			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW2R3qb.html" rel="bookmark">Java NIO系列教程（三） Buffer</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java NIO中的Buffer用于和NIO通道进行交互.如你所知,数据是从通道读入缓冲区,从缓冲区写入到通道中的. 缓冲区本质上是一块可以写入数据,然后可以从中读取数据的内存.这块内存被包装成NIO Buffer对象,并提供了一组方法,用来方便的访问该块内存. 下面是NIO Buffer相关的话题列表: Buffer的基本用法 Buffer的capacity,position和limit Buffer的类型 Buffer的分配 向Buffer中写数据 flip()方法 从Buffer中读取数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOWZv8z.html" rel="bookmark">Java NIO系列教程（三） Buffer&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java NIO中的Buffer用于和NIO通道进行交互.如你所知,数据是从通道读入缓冲区,从缓冲区写入到通道中的. 缓冲区本质上是一块可以写入数据,然后可以从中读取数据的内存.这块内存被包装成NIO Buffer对象,并提供了一组方法,用来方便的访问该块内存. 下面是NIO Buffer相关的话题列表: Buffer的基本用法 Buffer的capacity,position和limit Buffer的类型 Buffer的分配 向Buffer中写数据 flip()方法 从Buffer中读取数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXj3O4b.html" rel="bookmark">理解Java NIO</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基础概念 • 缓冲区操作 缓冲区及操作是所有I/O的基础,进程执行I/O操作,归结起来就是向操作系统发出请求,让它要么把缓冲区里的数据排干(写),要么把缓冲区填满(读).如下图 • 内核空间.用户空间  上图简单描述了数据从磁盘到用户进程的内存区域移动的过程,其间涉及到了内核空间与用户空间.这两个空间有什么区别呢?  用户空间就是常规进程(如JVM)所在区域,用户空间是非特权区域,如不能直接访问硬件设备.内核空间是操作系统所在区域,那肯定是有特权啦,如能与设备控制器通讯,控制用户区域的进程运行状			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRqGKab.html" rel="bookmark">攻破JAVA NIO技术壁垒</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现在使用NIO的场景越来越多,很多网上的技术框架或多或少的使用NIO技术,譬如Tomcat,Jetty.学习和掌握NIO技术已经不是一个JAVA攻城狮的加分技能,而是一个必备技能.再者,现在互联网的面试中上点level的都会涉及一下NIO或者AIO的问题(AIO下次再讲述,本篇主要讲述NIO),掌握好NIO也能帮助你获得一份较好的offer. 驱使博主写这篇文章的关键是网上关于NIO的文章并不是很多,而且案例较少,针对这个特性,本文主要通过实际案例主要讲述NIO的用法,每个案例都经过实际检验.博			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/apXoLlM.html" rel="bookmark">Java NIO API详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				详解 在JDK 1.4以前,Java的IO操作集中在java.io这个包中,是基于流的同步(blocking)API.对于大多数应用来说,这样的API使用很方便,然而,一些对性能要求较高的应用,尤其是服务端应用,往往需要一个更为有效的方式来处理IO.从JDK 1.4起,NIO API作为一个基于缓冲区,并能提供异步(non-blocking)IO操作的API被引入.本文对其进行深入的介绍. NIO API主要集中在java.nio和它的subpackages中: java.nio 定义了Buff			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZdPmOM.html" rel="bookmark">java NIO</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这次是关于java nio,有一些重复的发的地方.本文中的源代码可以在此处下载,下载链接为:http://115.com/file/cltlj10i#nio-src.zip 本文简介:  JDK 1.4 中引入的新输入输出 (NIO) 库在标准 Java 代码中提供了高速的.面向块的 I/O.本实用教程从高级概念到底层的编程细节,非常详细地介绍了 NIO 库.您将学到诸如缓冲区和通道这样的关键 I/O 元素的知识,并考察更新后的库中的标准 I/O 是如何工作的.您还将了解只能通过 NIO 来完成			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M06KPz.html" rel="bookmark" class="title">不用企业管理器的情况下得知CHECK约束的属性设置</a>
					<div>
						我们知道,在SQL SERVER企业管理器中,在&quot;设计表&quot;状态下,当查看该表的CHECK约束时,会看到CHECK约束有&quot;创建中检查现存数据&quot;.&quot;对复制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zG403b.html" rel="bookmark" class="title">PS打造清晰的青黄色摩天轮</a>
					<div>
						本教程的处理过程比较综合.作者除了调色之外,还用一些专业的HDR滤镜增强了图片的对比和清晰度,并给图片的天空部分增加了云彩. 本教程的处理过程比较综合.作者除了调色之外,还用一些专业的HDR滤镜增强了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNxv8b.html" rel="bookmark" class="title">SVN快速入门2：windows下的操作</a>
					<div>
						上一篇文章介绍了如果用命令行执行svn命令,比较繁琐,下面将介绍在 windows下进行svn操作. 为了安全着想,一般不允许匿名用户.所以将repository\conf目录下的 svnserve. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRy4VBb.html" rel="bookmark" class="title">Delphi 7中快速获取本机IP地址</a>
					<div>
						朋友们在用Delphi编程序的时候,常常碰到需要在程序中获取自己的IP地址的情况.在以往的版本中,可以通过编写一段代码或函数实现这一功能.但有了Delphi 7,这个工作可以更简化了.利用控件只需一句 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kmLqz.html" rel="bookmark" class="title">电脑关不了机怎么回事及解决办法</a>
					<div>
						  电脑关不了机怎么回事及解决办法          下面我们一起来看看具体内容. 一.为什么电脑关不了机 1.最常见的就是电脑中了木马或者病毒,在受到木马或者病毒的影响下,导致电脑的一些驱动不能正常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEl2Onz.html" rel="bookmark" class="title">验证实例名称是否正确</a>
					<div>
						 在与 SQL Server 建立连接时出现与网络相关的或特定于实例的错误.未找到或无法访问服务器.请验证实例名称是否正确并且 SQL Server 已配置为允许远程连接. (provider: 命名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLPVOb.html" rel="bookmark" class="title">照片管理软件照片看看使用方法</a>
					<div>
						  最近,越来越多的网友选择一款可以有效保护用户隐私功能的无线照片管理软件--照片看看.使用该软件,用户可以实现在平板.手机.PC.笔记本等多平台的设备,无线查看和管理照片,甚至无需安装任何APP都可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2ODep.html" rel="bookmark" class="title">Photoshop把普通照片转卡通效果</a>
					<div>
						利用Photoshop两个滤镜轻松把普通照片转化为卡通效果.         三联推荐:photoshop7.0迷你版免费下载    |  Photoshop CS5 中文免费下载  |  photo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AaERp.html" rel="bookmark" class="title">给PowerPoint2007图片添加备注信息</a>
					<div>
						  ①打开PowerPoint2007,单击菜单栏上的插入--图片. ②选择一张图片,传到PowerPoint2007中. ③然后单击自选图形,插入线条. ④下面是文本框的输入,单击菜单栏--插入-- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgK8xBM.html" rel="bookmark" class="title">Powerpoint的动画刷是什么</a>
					<div>
						  动画刷与Microsoft Offices办公软件中word中的&quot;格式刷&quot;功能类似,Powerpoint 2010中也增添了&quot;动画刷&quot;之一工具,用它可以轻松 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1E6j3M.html" rel="bookmark" class="title">win7系统下使用Outlook Express管理原始邮件及回复邮件的方法</a>
					<div>
						  1.在Outlook Express中通过这样的设置,选择一个收件箱,选择&quot;查看&quot;→&quot;当前视图&quot;→&quot;按对话分组邮件&quot;,即可将邮件的回复组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3omK0b.html" rel="bookmark" class="title">xp系统下载文件没有出现下载对话框</a>
					<div>
						xp系统下载文件没有出现下载对话框问题的具体描述:下载的文件通常是压缩文件,其他类型的文件小编没去尝试.因为这是一个朋友问我的问题,而下载完zip或RAR文件后,不止没下载对话框,让你选择保存的位置, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0W98Jb.html" rel="bookmark" class="title">mac登陆界面不显示客人用户解决方法</a>
					<div>
						  mac登陆界面显示&quot;客人用户&quot;这是一个老问题了,不过还是经常会有朋友问到这个问题,今天小编就跟新手朋友分享下解决这个问题的方法吧~问题如下图所示: 其实很简单,大家只需进行一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywDJvz.html" rel="bookmark" class="title">U盘量产工具的一般知识</a>
					<div>
						  又到了U盘知识普及时间了,这次我们就来说说量产工具的问题. 量产工具其实就是一个集扫描和文件系统装载于一身的一种工具,他首先对整个flash进行扫描,来判断所有的块是好还是坏,至于各家方案的级别, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNVaVz.html" rel="bookmark" class="title">透过pageinspect了解PostgreSQl中的page</a>
					<div>
						        博客 PostgreSQL的Page分析记录 有过对page的 大体介绍,可以参看之前的blog,下面主要通过插件 pageinspect 向大家进行介绍.         在此之前需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlDaxb.html" rel="bookmark" class="title">泛金融账务流水 存储与快照回溯查询 案例分享</a>
					<div>
						标签 PostgreSQL , 金融 , 审计数据 , feed , 轨迹数据 , 明细数据 , 快照 , 滑动窗口 , binlog , oss 背景 在金融行业中,或者一些含有支付业务,往来对账业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/MrWLAyp.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vbW1iaXoucXBpYy5jbi9tbWJpei93YzdZTlBtM1l4WDljTTcwYXJTb2NKc3JxMFdnZnhJb0J2cXVLenBDU282dmJPdnZac0tCcE5Namljc3BMMmtCT3lWNTJVeEFJWGhjZkNiZXFTVlJpYVNBLzA=.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/MrWLAyp.html" rel="bookmark" class="title">硅谷移动医疗有多牛？</a>
					<div>
						对刚刚过去2014年,如果请大家用一个词来形容移动医疗格局,大家会用什么?很多人在对2014年移动医疗总结时都用了&quot;异常火热&quot;这个词.其实,这种火热也不光是中国独有的,美国著名的移 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32g3Jz.html" rel="bookmark" class="title">侯伯薇｜学习、思考与分享&mdash;快速有效提升能力的正向循环</a>
					<div>
						扉页图:Free-Photos@Pixabay 作者:侯伯薇 编辑:冷锋 前言:在当今这个快节奏.高强度.竞争激烈的时代环境下,你是否期望: • 拥有更好的职位 • 拥有更高的业界地位 • 为团队做出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ6Z0z.html" rel="bookmark" class="title">linux包编译失败-Linux安装R语言，报编译失败！</a>
					<div>
						问题描述 Linux安装R语言,报编译失败! Error:compilation failed for package 'Rserve' 说包编译失败! 貌似说版本问题,于是换了几个版本还是不行! R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRD2Kp.html" rel="bookmark" class="title">Int32怎么强制转换为string类型</a>
					<div>
						问题描述 pr.Age1=Int32.Parse(this.textBox2.Text.Trim()); 解决方案 本帖最后由 OnlyInNew 于 2016-01-28 02:51:18 编辑解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKnm0z.html" rel="bookmark" class="title">c&num;-请教C&num;转vb&period;net的问题，伤脑筋</a>
					<div>
						问题描述 请教C#转vb.net的问题,伤脑筋 那位大神给我转换一下,我自己弄了几天了,但是没有办法,特别是搞不懂例子里面SKinForm里面的Init函数有什么用,是C#默认调用的吗?因为我在整个程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKjNDb.html" rel="bookmark" class="title">select-sql拼接表名问题急急急急急急</a>
					<div>
						问题描述 sql拼接表名问题急急急急急急 ORA-00906: 缺失左括号 Query: SELECT * FROM table =? WHERE F_DWMC=? AND F_YWBMMC=? AN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYr2jp.html" rel="bookmark" class="title">mybaits参数是英文可以查询数据 ，输入中文查询不出来，求大神帮忙</a>
					<div>
						问题描述 mybaits参数是英文可以查询数据 ,输入中文查询不出来,求大神帮忙 用的是mysql数据库 控制台打印出来的sql 放到数据库中可以查询出来数据, 参数传到mybaits 中是中文的 为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRn0Ab.html" rel="bookmark" class="title">java-百度贴吧一键签到原理</a>
					<div>
						问题描述 百度贴吧一键签到原理 有人做过百度贴吧一键签到的软件么 或者类似的 出来和小白分享下经验可好 或者大神出来讲讲原理嘛.. 我也想上手自己做 解决方案 http://tieba.baidu.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeR3rjb.html" rel="bookmark" class="title">阿里巴巴买下1688&period;com域名 推出网上批发市场</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 2010年1月19日消息,据消息人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnR5VM.html" rel="bookmark" class="title">vivo X7Plus手机怎么开启省电模式方法</a>
					<div>
						vivo X7Plus怎么开启省电模式教程 1.打开[i管家],找到[省电管理]. 2.最后我们再选择自己需要的省电模式就可以了. 好了我们在手机的管理中找到这个省电管理就可以了,操作的步骤方法是非常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLwk8M.html" rel="bookmark" class="title">Ext&period;PagingToolbar带条件查询问题</a>
					<div>
						问题描述 一个JSON Store,默认查询全部都没问题一开始是store.load({params:{start:0,limit:10}});加了个条件,store.load({params:{st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeV3lM.html" rel="bookmark" class="title">关于查询的设计问题</a>
					<div>
						问题描述 我用SSH开发Web应用.现在有一个问题一直困扰着我.对于数据的增.删.改很好设计了.前台页面表单传入参数以后,action类将值填充到实体对象里,然后将实体传给Service的增.删.改方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAERQ3M.html" rel="bookmark" class="title">管理型SaaS：实现资金与物流的动态管理</a>
					<div>
						管理型SaaS服务可实现对企业的信息流.物流和资金流的有效动态管理,中小企业采用管理型SaaS对企业流程管理将为企业带来增收.节支.提效和避险方面的变化: 首先是增加企业的营收.从赢取客户数量.获得客 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr22D1M.html" rel="bookmark" class="title">Docker创建镜像两种方法详解&lowbar;docker</a>
					<div>
						 Docker创建镜像             最近学习Docker 的知识,偶然在网上看到关于Docker 创建对象的两种方法很好,这里记录下,也许可以帮助到你.  我们都知道Docker中我们是基 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
